package com.qmth.distributed.print.api;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.annotation.BOOL;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.teachcloud.common.bean.dto.OrgDto;
import com.qmth.teachcloud.common.bean.dto.SysRolePrivilegeDto;
import com.qmth.teachcloud.common.entity.SysPrivilege;
import com.qmth.teachcloud.common.entity.SysRolePrivilege;
import com.qmth.teachcloud.common.service.SysPrivilegeService;
import com.qmth.teachcloud.common.service.SysRolePrivilegeService;
import com.qmth.teachcloud.common.util.Result;
import com.qmth.teachcloud.common.util.ResultUtil;
import io.swagger.annotations.*;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.*;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * @Description: 菜单权限修改
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2021/10/29
 */
@Api(tags = "菜单权限修改Controller")
@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/${prefix.url.menu}")
@Aac(auth = BOOL.FALSE, strict = BOOL.FALSE)
@Validated
public class MenuUpdateController {

    @Resource
    SysPrivilegeService sysPrivilegeService;

    @Resource
    SysRolePrivilegeService sysRolePrivilegeService;

//    @ApiOperation(value = "同步所有角色菜单权限")
//    @ApiResponses({@ApiResponse(code = 200, message = "常规信息", response = ResultUtil.class)})
//    @RequestMapping(value = "/rolePrivilegeSync", method = RequestMethod.POST)
//    @Transactional
//    public Result rolePrivilegeSync() {
//        List<SysRolePrivilegeDto> sysRolePrivilegeDtoList = sysPrivilegeService.getRolePrivilegeList();
//        if (Objects.nonNull(sysRolePrivilegeDtoList) && sysRolePrivilegeDtoList.size() > 0) {
//            Map<Long, List<SysRolePrivilegeDto>> map = new HashMap<>();
//            for (SysRolePrivilegeDto s : sysRolePrivilegeDtoList) {
//                if (!map.containsKey(s.getRoleId())) {
//                    List<SysRolePrivilegeDto> tempList = new ArrayList<>();
//                    tempList.add(s);
//                    map.put(s.getRoleId(), tempList);
//                } else {
//                    List<SysRolePrivilegeDto> mapList = map.get(s.getRoleId());
//                    mapList.add(s);
//                    map.put(s.getRoleId(), mapList);
//                }
//            }
//            List<SysPrivilege> sysPrivilegeList = sysPrivilegeService.findByDefault();
//            Map<String, SysPrivilege> sysPrivilegeMap = sysPrivilegeList.stream().collect(Collectors.toMap(SysPrivilege::getName, Function.identity(), (dto1, dto2) -> dto1));
//            map.forEach((k, v) -> {
//                List<SysRolePrivilege> sysRolePrivilegeList = new ArrayList<>();
//                for (int i = 0; i < v.size(); i++) {
//                    SysRolePrivilegeDto s = v.get(i);
//                    SysRolePrivilege sysRolePrivilege = sysRolePrivilegeService.getById(s.getRolePrivilegeId());
//                    SysPrivilege sysPrivilege = sysPrivilegeMap.get(s.getPrivilegeName());
//                    if (Objects.nonNull(sysPrivilege)) {
//                        sysRolePrivilege.setPrivilegeId(sysPrivilege.getId());
//                        sysRolePrivilegeList.add(sysRolePrivilege);
//                    }
//                }
//                sysRolePrivilegeService.saveOrUpdateBatch(sysRolePrivilegeList);
//            });
//        }
//        return ResultUtil.ok(true);
//    }
//
//    @ApiOperation(value = "同步所有角色菜单权限数量")
//    @ApiResponses({@ApiResponse(code = 200, message = "常规信息", response = ResultUtil.class)})
//    @RequestMapping(value = "/rolePrivilegeCountSync", method = RequestMethod.POST)
//    @Transactional
//    public Result rolePrivilegeCountSync() {
//        Integer count = sysPrivilegeService.getRolePrivilegeCount();
//        return ResultUtil.ok(Objects.nonNull(count) ? count : 0);
//    }
}
